<?php

namespace Ecentral\PunchCommerce\Helper;

use Magento\Checkout\Model\Session;
use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\App\Helper\Context;
use Magento\Quote\Model\QuoteFactory;

class Cart extends AbstractHelper
{
    protected Session $checkoutSession;
    protected QuoteFactory $quoteFactory;

    public function __construct(Session $checkoutSession, QuoteFactory $quoteFactory, Context $context)
    {
        $this->checkoutSession = $checkoutSession;
        $this->quoteFactory = $quoteFactory;
        parent::__construct($context);
    }

    public function initPunchoutQuote($customer)
    {
        $quote = $this->quoteFactory->create();
        $quote->setStoreId($this->checkoutSession->getQuote()->getStoreId());
        $quote->setCustomer($customer);
        $quote->save();
        $this->checkoutSession->replaceQuote($quote);
    }
}
