<?php

namespace Ecentral\PunchCommerce\Plugin\Cookie;

use Ecentral\PunchCommerce\Helper\Config;
use Magento\Framework\Stdlib\Cookie\CookieMetadata;

class CookieMetadataPlugin
{
    public function __construct(private Config $config)
    {
    }

    public function beforeSetSameSite(CookieMetadata $metadata, $samesite)
    {
        if (!$this->config->isActive()) {
            return [$samesite];
        }
        return ['None'];
    }

    public function after__toArray(CookieMetadata $metadata, $metadataArray)
    {
        if ($this->config->isActive()) {
            $metadataArray['secure'] = true;
            $metadataArray['path'] = $metadataArray['path'] ?: '/';
            $metadataArray['samesite'] = 'None';
        }
        return $metadataArray;
    }
}
