<?php

namespace Ecentral\PunchCommerce\Plugin\Cookie;

use Ecentral\PunchCommerce\Helper\Config;
use Magento\Framework\Stdlib\Cookie\PublicCookieMetadata;

class PublicCookieMetadataPlugin
{
    public function __construct(private Config $config)
    {
    }

    public function beforeSetSameSite(PublicCookieMetadata $metadata, $samesite)
    {
        if (!$this->config->isActive()) {
            return [$samesite];
        }
        $metadata->setSecure(true);
        return ['None'];
    }

    public function beforeSetSecure(PublicCookieMetadata $metadata, $secure)
    {
        if (!$this->config->isActive()) {
            return [$secure];
        }
        return [true];
    }

    public function after__toArray(PublicCookieMetadata $metadata, $metadataArray)
    {
        if ($this->config->isActive()) {
            $metadataArray['secure'] = true;
            $metadataArray['path'] = $metadataArray['path'] ?: '/';
            $metadataArray['samesite'] = 'None';
        }
        return $metadataArray;
    }
}
