<?php

namespace Ecentral\PunchCommerce\Plugin;

use Ecentral\PunchCommerce\Helper\Config;
use Magento\Csp\Model\Collector\Config\FetchPolicyReader;

class CspAncestorPlugin
{
    public function __construct(private Config $config)
    {
    }

    public function beforeRead(FetchPolicyReader $policyReader, $id, $value)
    {
        if ($this->config->isActive() && $id === 'frame-ancestors') {
            $hosts = !empty($value['hosts']) ? array_values($value['hosts']) : [];
            $hosts []= $this->config->getFrameAncestor();
            $value['hosts'] = $hosts;
        }
        return [$id,$value];
    }
}
