<?php

namespace Ecentral\PunchCommerce\Plugin\Session;

use Ecentral\PunchCommerce\Helper\Config;

class GenericPlugin
{
    public function __construct(private Config $config)
    {
    }

    public function beforeStart()
    {
        $this->setCookieParams();
        return [];
    }

    public function beforeRegenerateId()
    {
        $this->setCookieParams();
        return [];
    }

    public function setCookieParams()
    {
        if (!$this->config->isActive()) {
            return;
        }
        $params = session_get_cookie_params();
        $secure = $params['secure'] ?? false;
        $sameSite = $params['samesite'] ?? '';
        if (!empty($secure) && !empty($sameSite) && (strtolower($sameSite) === 'none')) {
            return $this;
        }
        $params['secure'] = true;
        $params['samesite'] = 'None';
        session_set_cookie_params($params);
    }
}
