<?php

namespace Ecentral\PunchCommerce\Plugin\Session;

use Magento\Framework\Session\Config;

class SessionConfigPlugin
{
    public function __construct(private \Ecentral\PunchCommerce\Helper\Config $config)
    {
    }

    public function beforeSetCookieSecure(Config $config, $cookieSecure)
    {
        if (!$this->config->isActive()) {
            return [$cookieSecure];
        }
        return [true];
    }

    public function beforeSetCookieSameSite(Config $config, string $cookieSameSite = 'Lax')
    {
        if (!$this->config->isActive()) {
            return [$cookieSameSite];
        }
        return ['None'];
    }

    public function afterGetCookieSecure(Config $config, $result)
    {
        if (!$this->config->isActive()) {
            return $result;
        }
        return true;
    }

    public function afterGetCookieSameSite(Config $config, $result)
    {
        if (!$this->config->isActive()) {
            return $result;
        }
        return 'None';
    }

    public function afterGetOptions(Config $config, $options)
    {
        if ($this->config->isActive()) {
            $options["session.cookie_secure"] = true;
            $options['session.cookie_samesite'] = 'None';
        }
        return $options;
    }
}
