<?php

namespace Ecentral\PunchCommerce\Plugin;

use Ecentral\PunchCommerce\Helper\Config;
use Magento\Checkout\Api\Data\TotalsInformationInterface;
use Magento\Checkout\Api\TotalsInformationManagementInterface;
use Magento\Customer\Model\Session;

class TotalsInformationManagementPlugin
{
    protected Session $session;
    protected \Magento\Checkout\Model\Session $checkoutSession;

    public function __construct(
        Session $session,
        \Magento\Checkout\Model\Session $checkoutSession,
        private Config $config
    ) {
        $this->session = $session;
        $this->checkoutSession = $checkoutSession;
    }

    public function beforeCalculate(
        TotalsInformationManagementInterface $totalsInformationManagement,
        $cartId,
        TotalsInformationInterface $addressInformation
    ) {
        return [$this->config->isActive() ? $this->checkoutSession->getQuoteId() : $cartId, $addressInformation];
    }
}
